import { WidgetLibraryService } from '../widgets/widget-library.service';
export declare type Framework = {
    framework: any;
    widgets?: {
        [key: string]: any;
    };
    stylesheets?: string[];
    scripts?: string[];
};
export declare type FrameworkLibrary = {
    [key: string]: Framework;
};
export declare class FrameworkLibraryService {
    private widgetLibrary;
    private activeFramework;
    private stylesheets;
    private scripts;
    private loadExternalAssets;
    private defaultFramework;
    private frameworkLibrary;
    constructor(widgetLibrary: WidgetLibraryService);
    private registerFrameworkWidgets(framework);
    private unloadFrameworkExternalAssets();
    private loadFrameworkExternalAssets(framework);
    setLoadExternalAssets(loadExternalAssets?: boolean): void;
    setFramework(framework?: string | Framework, loadExternalAssets?: boolean): boolean;
    hasFramework(type: string): boolean;
    getFramework(): any;
    getFrameworkWidgets(): any;
    getFrameworkStylesheets(): string[];
    getFrameworkScritps(): string[];
}
